#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire600four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire600four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four6004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four6004xi = {
                1:'103x-13y590z',
                2:'105x-123y577z',
                3:'109x-8y589z',
                4:'112x-238y538z',
                5:'116x-122y575z',
                6:'116x-2y588z',
                7:'122x-574y123z',
                8:'126x-120y574z',
                9:'127x-236y536z',
                10:'136x-117y572z',
                11:'142x-234y533z',
                12:'147x-113y570z',
                13:'152x-568y117z',
                14:'157x-108y568z',
                15:'157x-230y530z',
                16:'160x-338y468z',
                17:'168x-103y566z',
                18:'172x-226y528z',
                19:'178x-96y564z',
                20:'179x-334y464z',
                21:'182x-560y111z',
                22:'187x-221y525z',
                23:'188x-89y562z',
                24:'197x-82y560z',
                25:'199x-328y460z',
                26:'202x-214y522z',
                27:'207x-73y558z',
                28:'211x-551y105z',
                29:'215x-64y556z',
                30:'217x-207y519z',
                31:'219x-321y457z',
                32:'221x-412y375z',
                33:'224x-53y553z',
                34:'232x-199y516z',
                35:'232x-43y551z',
                36:'238x-312y453z',
                37:'239x-31y549z',
                38:'240x-540y99z',
                39:'244x-403y370z',
                40:'246x-189y513z',
                41:'246x-19y546z',
                42:'252x-6y544z',
                43:'257x-303y449z',
                44:'260x-179y509z',
                45:'267x-393y365z',
                46:'269x-528y93z',
                47:'273x-168y506z',
                48:'275x-292y445z',
                49:'286x-156y503z',
                50:'289x-381y361z',
                51:'294x-281y441z',
                52:'296x-513y87z',
                53:'298x-143y500z',
                54:'30x-582y140z',
                55:'310x-129y496z',
                56:'311x-268y437z',
                57:'311x-368y356z',
                58:'321x-114y493z',
                59:'323x-498y82z',
                60:'328x-254y432z',
                61:'331x-99y490z',
                62:'333x-354y351z',
                63:'341x-82y486z',
                64:'345x-238y428z',
                65:'349x-481y76z',
                66:'349x-65y483z',
                67:'353x-338y346z',
                68:'357x-47y479z',
                69:'35x-27y598z',
                70:'360x-222y424z',
                71:'364x-29y475z',
                72:'370x-10y472z',
                73:'373x-321y341z',
                74:'375x-205y420z',
                75:'375x-463y70z',
                76:'389x-187y415z',
                77:'392x-304y336z',
                78:'399x-443y64z',
                79:'402x-168y411z',
                80:'40x-115y587z',
                81:'410x-284y331z',
                82:'414x-148y407z',
                83:'41x-28y597z',
                84:'422x-422y58z',
                85:'425x-127y402z',
                86:'427x-264y326z',
                87:'435x-106y398z',
                88:'444x-243y321z',
                89:'444x-399y52z',
                90:'444x-84y393z',
                91:'452x-61y389z',
                92:'458x-37y384z',
                93:'459x-221y316z',
                94:'464x-13y380z',
                95:'464x-376y46z',
                96:'472x-198y311z',
                97:'484x-351y40z',
                98:'48x-118y586z',
                99:'48x-29y597z',
                100:'502x-326y34z',
                101:'519x-299y28z',
                102:'534x-272y22z',
                103:'547x-243y16z',
                104:'55x-29y596z',
                105:'560x-214y10z',
                106:'566x-203y357z',
                107:'570x-185y4z',
                108:'57x-120y584z',
                109:'61x-581y135z',
                110:'62x-29y596z',
                111:'66x-122y583z',
                112:'69x-28y595z',
                113:'75x-124y582z',
                114:'76x-26y594z',
                115:'83x-24y593z',
                116:'85x-124y580z',
                117:'90x-21y592z',
                118:'91x-578y129z',
                119:'95x-124y579z',
                120:'96x-17y591z',
                121:'98x-238y541z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire600four4xi" usage = "target function for charge6004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire600four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE600FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE600FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE600FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE600FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE600FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four6004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE600FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE600FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE600FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four6004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four6004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE600FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE600FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE600FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire600four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    